<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IsLiftagoAvailable StructType
 * @subpackage Structs
 */
class IsLiftagoAvailable extends AbstractStructBase
{
    /**
     * The pickupAddress
     * @var \WpifyWoo\PacketeraSDK\StructType\Address
     */
    public $pickupAddress;
    /**
     * The deliveryAddress
     * @var \WpifyWoo\PacketeraSDK\StructType\Address
     */
    public $deliveryAddress;
    /**
     * Constructor method for IsLiftagoAvailable
     * @uses IsLiftagoAvailable::setPickupAddress()
     * @uses IsLiftagoAvailable::setDeliveryAddress()
     * @param \WpifyWoo\PacketeraSDK\StructType\Address $pickupAddress
     * @param \WpifyWoo\PacketeraSDK\StructType\Address $deliveryAddress
     */
    public function __construct(\WpifyWoo\PacketeraSDK\StructType\Address $pickupAddress = null, \WpifyWoo\PacketeraSDK\StructType\Address $deliveryAddress = null)
    {
        $this
            ->setPickupAddress($pickupAddress)
            ->setDeliveryAddress($deliveryAddress);
    }
    /**
     * Get pickupAddress value
     * @return \WpifyWoo\PacketeraSDK\StructType\Address|null
     */
    public function getPickupAddress()
    {
        return $this->pickupAddress;
    }
    /**
     * Set pickupAddress value
     * @param \WpifyWoo\PacketeraSDK\StructType\Address $pickupAddress
     * @return \WpifyWoo\PacketeraSDK\StructType\IsLiftagoAvailable
     */
    public function setPickupAddress(\WpifyWoo\PacketeraSDK\StructType\Address $pickupAddress = null)
    {
        $this->pickupAddress = $pickupAddress;
        return $this;
    }
    /**
     * Get deliveryAddress value
     * @return \WpifyWoo\PacketeraSDK\StructType\Address|null
     */
    public function getDeliveryAddress()
    {
        return $this->deliveryAddress;
    }
    /**
     * Set deliveryAddress value
     * @param \WpifyWoo\PacketeraSDK\StructType\Address $deliveryAddress
     * @return \WpifyWoo\PacketeraSDK\StructType\IsLiftagoAvailable
     */
    public function setDeliveryAddress(\WpifyWoo\PacketeraSDK\StructType\Address $deliveryAddress = null)
    {
        $this->deliveryAddress = $deliveryAddress;
        return $this;
    }
}
